SystemOrganization addCategory: #CryptographyKeyExchangeTests!

TestCase subclass: #CryptoDiffieHellmanTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CryptographyKeyExchangeTests'!

!CryptoDiffieHellmanTest methodsFor: 'testing' stamp: 'rww 10/5/2006 15:47'!
generator

	^ 19717436579274206947345122013064021491006648667525860934655329476450089156965164852462918009904002231332897658527803! !

!CryptoDiffieHellmanTest methodsFor: 'testing' stamp: 'rww 10/5/2006 15:46'!
prime

	^ 75736283208334870880874184828066736731062763491072315486250947429607562308928878772529680132938244784039544211105987! !

!CryptoDiffieHellmanTest methodsFor: 'testing' stamp: 'rww 10/5/2006 15:48'!
testDiffieHellman

	| alice bob fromAlice fromBob k1 k2 |
	alice := DiffieHellman prime: self prime generator: self generator.
	bob := DiffieHellman prime: self prime generator: self generator.
	fromAlice := alice sendMessage.
	fromBob := bob sendMessage.
	k1 := alice receiveMessage: fromBob.
	k2 := bob receiveMessage: fromAlice.
	self assert: k1 = k2! !

!CryptoDiffieHellmanTest methodsFor: 'testing' stamp: 'rww 10/5/2006 15:51'!
testDiffieHellmanWithGeneration

	| alice bob fromAlice fromBob k1 k2 |
	alice := DiffieHellman bits: 64.  "very low for speed"
	bob := DiffieHellman prime: alice prime generator: alice generator.
	fromAlice := alice sendMessage.
	fromBob := bob sendMessage.
	k1 := alice receiveMessage: fromBob.
	k2 := bob receiveMessage: fromAlice.
	self assert: k1 = k2! !
